## mingw-w64-adios2-2.10.2-1.src.tar.zst

=== plugins/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(operators)
add_subdirectory(engines)

=== python/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_custom_target(python_api ALL COMMAND ${CMAKE_COMMAND} -E copy_directory
                  ${CMAKE_CURRENT_SOURCE_DIR}/adios2
                  ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2)

set(install_location ${CMAKE_INSTALL_PYTHONDIR}/adios2)
if (ADIOS2_USE_PIP)
  set(install_location ${CMAKE_INSTALL_LIBDIR})
endif()

install(DIRECTORY ${CMAKE_PYTHON_OUTPUT_DIRECTORY}/adios2/
  DESTINATION ${install_location}
  COMPONENT adios2_python-python
)

=== source/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(adios2)

if (NOT ADIOS2_USE_PIP)
  add_subdirectory(utils)
endif()

if(ADIOS2_HAVE_HDF5_VOL)
  add_subdirectory(h5vol)
endif()

=== testing/utils/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

if(ADIOS2_HAVE_MPI)
  set(MPIEXEC_COMMAND ${MPIEXEC_EXECUTABLE} ${MPIEXEC_EXTRA_FLAGS})
  add_subdirectory(iotest)
else()
  set(MPIEXEC_COMMAND)
endif()

add_subdirectory(cwriter)
add_subdirectory(changingshape)

=== thirdparty/ffs/CMakeLists.txt ===
message_start_thirdparty()

set(BUILD_TESTING OFF)
set(CMAKE_INSTALL_CMAKEDIR "${CMAKE_INSTALL_CMAKEDIR}/thirdparty")

set(FFS_USE_ATL ON CACHE INTERNAL "")
set(FFS_USE_DILL ON CACHE INTERNAL "")
set(FFS_LIBRARIES_ONLY ON CACHE INTERNAL "")
set(FFS_QUIET ON CACHE INTERNAL "")
set(FFS_LIBRARY_PREFIX adios2${ADIOS2_LIBRARY_SUFFIX}_ CACHE INTERNAL "")
set(FFS_INSTALL_HEADERS OFF CACHE INTERNAL "")
set(FFS_INSTALL_PKGCONFIG OFF CACHE INTERNAL "")
set(FFS_CONVERSION_GENERATION_DEFAULT OFF CACHE INTERNAL "")
set(FFS_RUNTIME_COMPONENT adios2_ffs-runtime)
set(FFS_LIBRARY_COMPONENT adios2_ffs-libraries)
set(FFS_ARCHIVE_COMPONENT adios2_ffs-development)
set(FFS_HEADER_COMPONENT adios2_ffs-development)

add_subdirectory(ffs)
set(ffs_DIR ${CMAKE_CURRENT_BINARY_DIR}/ffs CACHE INTERNAL "")
setup_libversion_dir(ffs)

message_end_thirdparty()

=== examples/hello/bpStepsWriteReadHip/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2HelloBPStepsWriteReadHipExample)

if(NOT TARGET adios2_core)
  find_package(ADIOS2 REQUIRED COMPONENTS CXX)
endif()

enable_language(HIP)

# Needed for the hip cmake targets
find_package(hip REQUIRED)

add_executable(adios2_hello_bpStepsWriteReadHip bpStepsWriteReadHip.cpp)
target_link_libraries(adios2_hello_bpStepsWriteReadHip adios2::cxx11 hip::device)
set_source_files_properties(bpStepsWriteReadHip.cpp PROPERTIES LANGUAGE HIP)
install(TARGETS adios2_hello_bpStepsWriteReadHip RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/simulations/gray-scott/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2SimulationsGrayScottExample)

if(NOT TARGET adios2_core)
  set(_components CXX)

  find_package(MPI COMPONENTS C)
  if(MPI_FOUND)
    # Workaround for various MPI implementations forcing the link of C++ bindings
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)

    list(APPEND _components MPI)
  endif()

  find_package(ADIOS2 REQUIRED COMPONENTS ${_components})
endif()

if(ADIOS2_HAVE_MPI)
  add_executable(adios2_simulations_gray-scott
    simulation/main.cpp
    simulation/gray-scott.cpp
    simulation/settings.cpp
    simulation/writer.cpp
    simulation/restart.cpp
  )
  target_link_libraries(adios2_simulations_gray-scott adios2::cxx11_mpi MPI::MPI_C)
  install(TARGETS adios2_simulations_gray-scott RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  add_executable(adios2_simulations_gray-scott_pdf-calc analysis/pdf-calc.cpp)
  target_link_libraries(adios2_simulations_gray-scott_pdf-calc adios2::cxx11_mpi MPI::MPI_C)
  install(TARGETS adios2_simulations_gray-scott_pdf-calc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  install(FILES "adios2.xml" "adios2-inline-plugin.xml"
    "visit-bp4.session" "visit-bp4.session.gui"
    "visit-sst.session" "visit-sst.session.gui"
    "simulation/settings-files.json"
    "simulation/settings-staging.json"
    "simulation/settings-inline.json"
    "plot/decomp.py" "plot/gsplot.py" "plot/pdfplot.py"
    "ReadMe.md"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/adios2/gray-scott)

  install(DIRECTORY "catalyst" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/adios2/gray-scott)

  install(PROGRAMS "cleanup.sh" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/adios2/gray-scott)
endif()

=== testing/adios2/engine/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(bp)
add_subdirectory(skeleton)
add_subdirectory(inline)
add_subdirectory(null)
add_subdirectory(nullcore)

if(ADIOS2_HAVE_HDF5)
  add_subdirectory(hdf5)
endif()

if(ADIOS2_HAVE_DataMan)
  add_subdirectory(dataman)
endif()

if(ADIOS2_HAVE_MHS)
  add_subdirectory(mhs)
endif()

if(ADIOS2_HAVE_SST)
  add_subdirectory(sst)
endif()

if(ADIOS2_HAVE_MPI)
  add_subdirectory(ssc)
  add_subdirectory(common)
endif()

add_subdirectory(staging-common)

=== testing/examples/heatTransfer/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMx1.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxM.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxN.cmake)

include(${CMAKE_CURRENT_SOURCE_DIR}/TestInlineMxM.cmake)

if(ADIOS2_HAVE_ZFP)
  #include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxM_zfp.cmake)
  #include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxN_zfp.cmake)
  include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMx1_zfp.cmake)
endif()

if(ADIOS2_RUN_MPI_MPMD_TESTS)
  if(ADIOS2_HAVE_SST)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPMxM.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPMxN.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPMx1.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSMxM.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSMxN.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSMx1.cmake)
    if(ADIOS2_SST_HAVE_LIBFABRIC)
    #  include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPRDMAMxN.cmake)
    #  include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSRDMAMxN.cmake)
    endif()
  endif()
  if(NOT MSVC)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSCMxM.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSCMxN.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSCMx1.cmake)
  endif()
endif()

=== thirdparty/EVPath/EVPath/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# The directory label is used for CDash to treat EVPath as a subproject of
# GTKorvo
set(CMAKE_DIRECTORY_LABELS EVPath)

project(EVPath VERSION 4.5.0 LANGUAGES C CXX)

# Enable <PackageName>_ROOT variables for dependency searching
# CMake v3.12
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

# Enable imported targets as library dependencies for CHECK_INCLUDE_FILE
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

# Let option(...) setings work with non-cache variables.  Useful for including
# EVPath as a third party dependency in another project.
# CMake v3.13
if(POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif()

# Some boilerplate to setup nice output directories
include(GNUInstallDirs)
set(CMAKE_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/EVPath
  CACHE STRING "Installation CMake subdirectory")
mark_as_advanced(CMAKE_INSTALL_CMAKEDIR)

set(EVPATH_INSTALL_MODULE_DIR "${CMAKE_INSTALL_LIBDIR}"
  CACHE STRING "Directory in which to install EVPath transport modules")
mark_as_advanced(EVPATH_INSTALL_MODULE_DIR)

if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
endif()
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

if(NOT DEFINED EVPATH_RUNTIME_COMPONENT)
  set(EVPATH_RUNTIME_COMPONENT bin)
endif()
if(NOT DEFINED EVPATH_LIBRARY_COMPONENT)
  set(EVPATH_LIBRARY_COMPONENT shlib)
endif()
if(NOT DEFINED EVPATH_ARCHIVE_COMPONENT)
  set(EVPATH_ARCHIVE_COMPONENT lib)
endif()
if(NOT DEFINED EVPATH_HEADER_COMPONENT)
  set(EVPATH_HEADER_COMPONENT dev)
endif()
if(NOT DEFINED EVPATH_MODULE_COMPONENT_PREFIX)
  set(EVPATH_MODULE_COMPONENT_PREFIX "")
endif()

# Default to a RelWithDebInfo build if not specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE RelWithDebInfo)
endif()

if(NOT MSVC)
  set(CMAKE_C_STANDARD 99)
  set(CMAKE_C_STANDARD_REQUIRED True)
endif()

if(WIN32)
  # Automagic to do the DLL / LIB song and dance
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

  # Silence MSVC warnings
  if(CMAKE_C_COMPILER_ID MATCHES "MSVC" OR
     CMAKE_C_SIMULATE_ID MATCHES "MSVC")
    add_definitions(
      -D_CRT_SECURE_NO_DEPRECATE
      -D_CRT_SECURE_NO_WARNINGS
      -D_SCL_SECURE_NO_DEPRECATE
      -D_WINSOCK_DEPRECATED_NO_WARNINGS
      -D_CRT_NONSTDC_NO_DEPRECATE)
    set (MSVC_PERL_FLAGS "-msvc-long")
  endif()
endif()

set(CPACK_DEBIAN_PACKAGE_DEPENDS "dill, atl, ffs")
set(CPACK_RPM_PACKAGE_REQUIRES "dill, atl, ffs")
set(ENABLE_SOMETHING AUTO CACHE STRING "Enable SOMETHING support")  #
set(EVPATH_DEFAULT_PORT_RANGE  "26000:26100" CACHE STRING "Default port range for IP communication")
mark_as_advanced(EVPATH_DEFAULT_PORT_RANGE)

include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckTypeSize)
include(CheckStructHasMember)
include(CheckCSourceRuns)
include(TestBigEndian)
include(CheckBrokenTitanCompiler)

include(CTest)
configure_file(CTestCustom.ctest.in CTestCustom.ctest @ONLY)

include(CMakeDependentOption)

# Setup shared library defaults.  If explicitly specified somehow, then default 
# to that.  Otherwise base the default on whether or not shared libs are even
# supported.
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS
  "Build shared libraries (so/dylib/dll)." ${SHARED_LIBS_SUPPORTED}
  "SHARED_LIBS_SUPPORTED" OFF
)
mark_as_advanced(BUILD_SHARED_LIBS)

if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
elseif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  # Update if necessary
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall ")
endif()

add_library(EVPath
  cm.c cm_control.c cm_formats.c cm_util.c cm_transport.c 
  cm_lock.c cm_perf.c cm_pbio.c cm_interface.c version.c
  cm_threadio.c cm_evol.c evp.c response.c metrics.c 
  dlloader.c ip_config.c chr_time.c
  revp.c evp_compat.c thin_server.c evp_threads.c ev_dfg.c)
add_library(EVPath::EVPath ALIAS EVPath)
add_library(evpath ALIAS EVPath)
target_include_directories(EVPath PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

function(_pkg_get_target_prefix tgt out_prefix)
  set(prefix)
  get_property(inc TARGET ${tgt} PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
  get_filename_component(prefix "${inc}" PATH)
  set(${out_prefix} "${prefix}" PARENT_SCOPE)
endfunction()

set(_pkg_config_pfxs
  "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig")
set(_pkg_config_reqs)
set(_pkg_config_private_reqs)
set(_pkg_config_libs)
set(_pkg_config_private_libs)

include(CheckCSourceCompiles)

# Avoid recent compilers to optimizing out libm function calls
set(CMAKE_REQUIRED_FLAGS "-O0")
set(LIBM_TEST_SOURCE "#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}")
check_c_source_compiles("${LIBM_TEST_SOURCE}" HAVE_MATH)
if(NOT HAVE_MATH)
  set(CMAKE_REQUIRED_LIBRARIES m)
  check_c_source_compiles("${LIBM_TEST_SOURCE}" HAVE_LIBM_MATH)
  unset(CMAKE_REQUIRED_LIBRARIES)
  if(NOT HAVE_LIBM_MATH)
    message(FATAL_ERROR "Unable to use C math library functions")
  endif()
    
  target_link_libraries(EVPath PRIVATE m)
  list(APPEND _pkg_config_private_libs m)
endif()

set(EVPATH_LIBRARY_PREFIX "" CACHE STRING
  "Prefix to prepend to the output library name")
mark_as_advanced(EVPATH_LIBRARY_PREFIX)
set_target_properties(EVPath PROPERTIES
  OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}evpath)

set(IPCONFIG_ENVVAR_PREFIX "CM_" CACHE STRING
  "Prefix to prepend to the networking environment variable names")
mark_as_advanced(IPCONFIG_ENVVAR_PREFIX)
if (NOT EVPATH_LIBRARY_PREFIX STREQUAL "")
   STRING (TOUPPER ${EVPATH_LIBRARY_PREFIX} IPCONFIG_ENVVAR_PREFIX)
endif()
   
mark_as_advanced(EVPATH_LIBRARY_PREFIX)

set(EVPATH_TRANSPORT_DEP_LIBS)

if(NOT DEFINED CM_SELF_FORMATS)
  set(CM_SELF_FORMATS 1)
endif()

if (DEFINED EVPATH_NO_RDMA) 
  option(EVPATH_NO_RDMA "Don't use any RDMA library"
    "${EVPATH_NO_RDMA}")
  if (EVPATH_NO_RDMA)
    SET (EVPATH_USE_LIBFABRIC OFF)
    SET (EVPATH_USE_NNTI OFF)
    SET (EVPATH_USE_IBVERBS OFF)
  endif()
endif()

cmake_dependent_option(EVPATH_TRANSPORT_MODULES
  "Enable stand-alone transport modules" ${BUILD_SHARED_LIBS}
  "SHARED_LIBS_SUPPORTED" OFF
)

list(INSERT CMAKE_PREFIX_PATH 0 ${CMAKE_INSTALL_PREFIX})
find_package(atl 2.2.1 REQUIRED)
find_package(ffs 3.0.0 REQUIRED)
_pkg_get_target_prefix(atl::atl atl_PREFIX)
_pkg_get_target_prefix(ffs::ffs ffs_PREFIX)
list(APPEND _pkg_config_pfxs "${atl_PREFIX}" "${ffs_PREFIX}")

if(TARGET ffs) # The unaliased target exists so it's built by us
  set(HAVE_COD_H TRUE CACHE INTERNAL "" FORCE)
else()
  set(CMAKE_REQUIRED_LIBRARIES ffs::ffs)
  CHECK_INCLUDE_FILE(cod.h HAVE_COD_H)
  unset(CMAKE_REQUIRED_LIBRARIES)
endif()
if (HAVE_COD_H)
   find_package(dill 3.0.0 REQUIRED)
   target_link_libraries(EVPath PUBLIC atl::atl ffs::ffs PRIVATE dill::dill)
   _pkg_get_target_prefix(dill::dill dill_PREFIX)
   list(APPEND _pkg_config_private_reqs "dill >= ${dill_VERSION}")
   list(APPEND _pkg_config_pfxs "${dill_PREFIX}")
else()
   target_link_libraries(EVPath PUBLIC atl::atl ffs::ffs)
endif()

find_package(Threads)
if(Threads_FOUND)
  target_link_libraries(EVPath PRIVATE ${CMAKE_THREAD_LIBS_INIT})
  list(APPEND _pkg_config_private_libs ${CMAKE_THREAD_LIBS_INIT})
endif()

if(DEFINED EVPATH_USE_NVML)
  option(EVPATH_USE_NVML "Use the NVidia management library"
    "${EVPATH_USE_NVML}")
  if(EVPATH_USE_NVML)
    find_package(NVML REQUIRED)
  endif()
else()
  find_package(NVML)
  option(EVPATH_USE_NVML "Use the NVidia management library" ${NVML_FOUND})
endif()
if(NVML_FOUND)
  if(NOT BUILD_SHARED_LIBS)
    list(APPEND EXTRA_INSTALL_PACKAGES NVML)
  endif()
  target_link_libraries(EVPath PRIVATE nvml::nvml)
  list(APPEND _pkg_config_private_libs ${NVML_LIBRARIES})
endif()

include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(clock_gettime time.h HAVE_CLOCK_GETTIME)

if(NOT HAVE_CLOCK_GETTIME)
  include(CheckLibraryExists)
  CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME)
  if(HAVE_CLOCK_GETTIME)
    target_link_libraries(EVPath PRIVATE rt)
    list(APPEND _pkg_config_private_libs rt)
  endif()
endif()

CHECK_INCLUDE_FILE(sys/epoll.h HAVE_SYS_EPOLL_H)
set(CM_DEFAULT_SELECT "select")
if (HAVE_SYS_EPOLL_H)
   set(CM_DEFAULT_SELECT "epoll")
endif()
set(CM_DEFAULT_TRANSPORT "sockets")

# This is a dummy interace library to allow the transport modules to depend on
# the EVPath headers without causing an unnecessary link dependency
add_library(evpath_headers INTERFACE)
set_target_properties(evpath_headers PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES
    "${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR};$<TARGET_PROPERTY:ffs::ffs,INTERFACE_INCLUDE_DIRECTORIES>;$<TARGET_PROPERTY:atl::atl,INTERACE_INCLUDE_DIRECTORIES>"
)

set(EVPATH_TRANSPORT_TARGETS)
if(EVPATH_TRANSPORT_MODULES)
  target_link_libraries(EVPath PRIVATE ${CMAKE_DL_LIBS})

  add_library(cmselect MODULE cmselect.c)
  add_library(cmsockets MODULE cmsockets.c ip_config.c)
  add_library(cmudp MODULE cmudp.c)
  add_library(cmmulticast MODULE cmmulticast.c)

  foreach(M cmselect cmsockets cmudp cmmulticast)
    set_target_properties(${M} PROPERTIES
      OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}${M}
      LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${EVPATH_INSTALL_MODULE_DIR}
      WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    install(TARGETS ${M} DESTINATION ${EVPATH_INSTALL_MODULE_DIR} COMPONENT ${EVPATH_MODULE_COMPONENT_PREFIX}${M})
  endforeach()

  target_link_libraries(cmselect PRIVATE evpath_headers atl::atl)
  target_link_libraries(cmsockets PRIVATE evpath_headers atl::atl)
  target_link_libraries(cmudp PRIVATE evpath_headers atl::atl)
  target_link_libraries(cmmulticast PRIVATE evpath_headers atl::atl)

  list(APPEND EVPATH_TRANSPORT_TARGETS cmselect cmsockets cmudp cmmulticast)

  if (HAVE_SYS_EPOLL_H)
     add_library(cmepoll MODULE cmepoll.c)
     set_target_properties(cmepoll PROPERTIES
          OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}cmepoll
          LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${EVPATH_INSTALL_MODULE_DIR})
     target_link_libraries(cmepoll PRIVATE evpath_headers atl::atl)
     list(APPEND EVPATH_TRANSPORT_TARGETS cmepoll)
     install(TARGETS cmepoll DESTINATION ${EVPATH_INSTALL_MODULE_DIR} COMPONENT ${EVPATH_MODULE_COMPONENT_PREFIX}cmepoll)
  endif()
else()
  # dummy dyn linking in cm.c and cm_transport.c
  set(NO_DYNAMIC_LINKING 1)

  target_sources(EVPath PRIVATE cmsockets.c)
  target_sources(EVPath PRIVATE cmselect.c)
  if (HAVE_SYS_EPOLL_H)
    target_sources(EVPath PRIVATE cmepoll.c)
  endif()
  target_sources(EVPath PRIVATE cmudp.c)
  target_sources(EVPath PRIVATE cmmulticast.c)
endif()

set(RUN_NNTI_TESTS FALSE)

# enet transport
set(RUN_ENET_TESTS FALSE)
if(DEFINED EVPATH_USE_ENET)
  option(EVPATH_USE_ENET "Build the enet transport" "${EVPATH_USE_ENET}")
  if(EVPATH_USE_ENET)
    find_package(enet 1.3.13 REQUIRED)
  endif()
else()
  find_package(enet 1.3.13 QUIET)
  option(EVPATH_USE_ENET "Build the enet transport" ${ENET_FOUND})
endif()
if(ENET_FOUND)
  set(RUN_ENET_TESTS TRUE)
  if(EVPATH_TRANSPORT_MODULES)
    add_library(cmenet MODULE cmenet.c ip_config.c)
    set_target_properties(cmenet PROPERTIES
      OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}cmenet
      LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${EVPATH_INSTALL_MODULE_DIR})

=== examples/simulations/heatTransfer/readFileOnly/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2SimulationsHeatTransferReadFileOnlyExample)

if(NOT TARGET adios2_core)
  set(_components C CXX)

  find_package(MPI COMPONENTS ${_components})
  if(MPI_FOUND)
    # Workaround for various MPI implementations forcing the link of C++ bindings
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)

    list(APPEND _components MPI)
  endif()

  find_package(ADIOS2 REQUIRED COMPONENTS ${_components})
endif()

if(ADIOS2_HAVE_MPI)
  add_executable(adios2_simulations_heatTransferReadFileOnly heatReadFileOnly.cpp PrintData.h)
  target_link_libraries(adios2_simulations_heatTransferReadFileOnly adios2::cxx11_mpi MPI::MPI_C)
  install(TARGETS adios2_simulations_heatTransferReadFileOnly RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()

=== testing/adios2/engine/staging-common/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

find_package(Threads REQUIRED)

if(ADIOS2_HAVE_SST)
  gtest_add_tests_helper(StagingMPMD MPI_ONLY "" Engine.Staging. ".SST.FFS" EXTRA_ARGS "SST" "MarshalMethod=FFS")
  gtest_add_tests_helper(StagingMPMD MPI_ONLY "" Engine.Staging. ".SST.BP" EXTRA_ARGS "SST" "MarshalMethod=BP")
  gtest_add_tests_helper(OnDemandMPI MPI_ONLY "" Engine.Staging. ".SST" EXTRA_ARGS "SST" "OnDemandContact")
  gtest_add_tests_helper(Threads MPI_NONE "" Engine.Staging. ".SST.FFS" EXTRA_ARGS "SST"  "--engine_params" "MarshalMethod=FFS")
  gtest_add_tests_helper(Threads MPI_NONE "" Engine.Staging. ".SST.BP" EXTRA_ARGS "SST"  "--engine_params" "MarshalMethod=BP")
  gtest_add_tests_helper(Threads MPI_NONE "" Engine.Staging. ".BP4_stream" EXTRA_ARGS "BP4"  "--engine_params" "OpenTimeoutSecs=5")
  gtest_add_tests_helper(Threads MPI_NONE "" Engine.Staging. ".FileStream" EXTRA_ARGS "FileStream")
endif()

set (PROGS TestCommonWrite TestShapeChangingWrite
    TestCommonWriteModes
    TestCommonWriteAttrs
    TestCommonWriteLocal
    TestCommonWriteShared
    TestCommonSpanWrite
    TestDistributionWrite
    TestDefSyncWrite
    TestCommonRead
    TestCommonSpanRead
    TestCommonReadR64
    TestCommonReadLocal
    TestCommonReadShared
    TestCommonReadAttrs
    TestCommonServer
    TestCommonClient
    TestDistributionRead
    TestLocalWrite
    TestLocalRead
    TestStructWrite
    TestStructRead
    TestWriteJoined
    TestReadJoined
    TestOnDemandWrite
    TestOnDemandRead)

foreach(helper ${PROGS} )
  add_executable(${helper} ${helper}.cpp)

  # Workaround for multiple versions of FindSst
  if(SST_INCLUDE_DIRS)
    target_include_directories(${helper} PRIVATE ${SST_INCLUDE_DIRS})
  endif()

  target_link_libraries(${helper} adios2::thirdparty::gtest ${Sst_LIBRARY})
  if(ADIOS2_HAVE_MPI)
    target_link_libraries(${helper} adios2::cxx11_mpi adios2_core_mpi MPI::MPI_C)
  else()
    target_link_libraries(${helper} adios2::cxx11 adios2_core)
  endif()
endforeach()

if(ADIOS2_HAVE_Fortran)
  add_library(TestCommonData_f OBJECT TestData_mod.F90)
  add_executable(TestCommonWrite_f
    TestCommonWriteF.F90
    $<TARGET_OBJECTS:TestCommonData_f>
  )
  add_executable(TestCommonRead_f
    TestCommonReadF.F90
    $<TARGET_OBJECTS:TestCommonData_f>
  )
  target_compile_definitions(TestCommonRead_f PRIVATE
    $<$<BOOL:${ADIOS2_HAVE_FORTRAN_F03_ARGS}>:ADIOS2_HAVE_FORTRAN_F03_ARGS>
    $<$<BOOL:${ADIOS2_HAVE_FORTRAN_GNU_ARGS}>:ADIOS2_HAVE_FORTRAN_GNU_ARGS>
  )
  set_target_properties(TestCommonWrite_f TestCommonRead_f PROPERTIES
    LINKER_LANGUAGE Fortran
  )
  target_compile_definitions(TestCommonWrite_f PRIVATE
    $<$<BOOL:${ADIOS2_HAVE_FORTRAN_F03_ARGS}>:ADIOS2_HAVE_FORTRAN_F03_ARGS>
    $<$<BOOL:${ADIOS2_HAVE_FORTRAN_GNU_ARGS}>:ADIOS2_HAVE_FORTRAN_GNU_ARGS>
  )
  if(ADIOS2_HAVE_MPI)
    target_link_libraries(TestCommonWrite_f adios2_fortran_mpi MPI::MPI_Fortran)
    target_link_libraries(TestCommonRead_f adios2_fortran_mpi MPI::MPI_Fortran)
  else()
    target_link_libraries(TestCommonWrite_f adios2_fortran)
    target_link_libraries(TestCommonRead_f adios2_fortran)
  endif()
endif()

configure_file(
  run_test.py.gen.in
  ${CMAKE_CURRENT_BINARY_DIR}/run_test.py.gen
  @ONLY
)
file(GENERATE
  OUTPUT ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/run_test.py.$<CONFIG>
  INPUT ${CMAKE_CURRENT_BINARY_DIR}/run_test.py.gen)

include (TestSupp.cmake )

if(ADIOS2_HAVE_MPI AND MPIEXEC_EXECUTABLE)
   # we want to know if mpiexec is a shell script or a binary executable
   file(READ ${MPIEXEC_EXECUTABLE} MPIFILEDATA LIMIT 1024 HEX)
   string(LENGTH ${MPIFILEDATA} DATALENGTH)
   math(EXPR last_hex_index "(${DATALENGTH} / 2) - 1")
   foreach(hex_index RANGE ${last_hex_index})
      math (EXPR str_loc "2*${hex_index}")
      string(SUBSTRING "${MPIFILEDATA}" "${str_loc}" "2" char)
      #math (EXPR dec_char "0x${char}" )
      from_hex(${char} dec_char)
      if ((${dec_char} LESS 9) OR (${dec_char} GREATER 126) OR ((${dec_char} GREATER 13) AND (${dec_char} LESS 32)))
          #  message ("$character ${char} is outside of the printable/character ascii range")
	  set (MPIEXEC_IS_BINARY TRUE)
	  break()
      endif()
   endforeach()
endif()

set (SIMPLE_TESTS "1x1;1x1.Attrs;1x1.ModAttrs;1x1DefSync;1x1VarDestruction;1x1.SpanMinMax;1x1.Local2;1x1Struct;1x1Joined")
set (BP5File_ONLY_TESTS "1x1DataWrite;1x1.ShapeChange")

set (SIMPLE_FORTRAN_TESTS "")
if(ADIOS2_HAVE_Fortran)
  set (SIMPLE_FORTRAN_TESTS "FtoC.1x1;CtoF.1x1;FtoF.1x1")
endif()

set (SPECIAL_TESTS "TimeoutReader.1x1;LatestReader.1x1;LatestReaderHold.1x1;DiscardWriter.1x1;1x1.NoPreload;1x1.ForcePreload;1x1LockGeometry")
if (MPIEXEC_IS_BINARY)
    # run_test.py can only kill readers/writers if mpiexec is not a shell script
    list(APPEND SPECIAL_TESTS "KillReadersSerialized.3x2;KillReaders3Max.3x6;KillWriter_2x2;KillWriterTimeout_2x2")
endif()

set (SIMPLE_MPI_TESTS "")
set (SIMPLE_MPI_FORTRAN_TESTS "")
if (ADIOS2_HAVE_MPI)
  set (SIMPLE_MPI_TESTS "2x1;1x2;3x5;5x3;DelayedReader_3x5;3x5LockGeometry;2x1.Local;1x2.Local;3x5.Local;5x3.Local;1x1.LocalVarying;5x3.LocalVarying;2x1ZeroDataVar;2x1ZeroDataR64;2x2.NoData;2x2.HalfNoData;2x1.SharedNothing;2x1.SharedIO;2x1.SharedVar;2x1.SharedNothingSync;2x1.SharedIOSync;2x1.SharedVarSync;3x5EarlyExit;;5x1Joined")
  list (APPEND SPECIAL_TESTS "2x1.NoPreload;2x3.ForcePreload;PreciousTimestep.3x2;PreciousTimestepDiscard.3x2")
  if (ADIOS2_HAVE_Fortran)
    set (SIMPLE_MPI_FORTRAN_TESTS "FtoC.3x5;CtoF.3x5;FtoF.3x5")
  endif()
endif()
 
set (SIMPLE_ZFP_TESTS "")
if (ADIOS2_HAVE_ZFP)
   set (SIMPLE_ZFP_TESTS "ZFPCompression.1x1;ZFPCompression.3x5")
endif()

set (ALL_SIMPLE_TESTS "")
list (APPEND ALL_SIMPLE_TESTS ${SIMPLE_TESTS} ${SIMPLE_FORTRAN_TESTS} ${SIMPLE_MPI_TESTS} ${SIMPLE_ZFP_TESTS})

set (SST_SPECIFIC_TESTS  "")
import_bp_test(WriteMemorySelectionRead 1 1)
list (APPEND SST_SPECIFIC_TESTS  "WriteMemorySelectionRead.1x1")
list (APPEND SST_SPECIFIC_TESTS  "1x1.SstRUDP;1x1.LocalMultiblock;RoundRobinDistribution.1x1x3;AllToAllDistribution.1x1x3;OnDemandSingle.1x1")

if (ADIOS2_HAVE_MPI)
  import_bp_test(WriteMemorySelectionRead 3 3)
  list (APPEND SST_SPECIFIC_TESTS  "WriteMemorySelectionRead.3x3")
  list (APPEND SST_SPECIFIC_TESTS  "2x3.SstRUDP;2x1.LocalMultiblock;5x3.LocalMultiblock;")
endif()

#
#   Setup tests for SST engine
#
SET (BASIC_SST_TESTS "")
if(ADIOS2_HAVE_SST)
  list (APPEND BASIC_SST_TESTS ${ALL_SIMPLE_TESTS} ${SPECIAL_TESTS} ${SST_SPECIFIC_TESTS})
  list (REMOVE_ITEM BASIC_SST_TESTS 1x1DefSync 1x1Flush)
  list (REMOVE_ITEM BASIC_SST_TESTS 1x1.SpanMinMax)
endif()


#  For the moment, only test the default comm pattern (Min)
MutateTestSet( COMM_MIN_SST_TESTS "CommMin" writer "CPCommPattern=Min" "${BASIC_SST_TESTS}" )
#MutateTestSet( COMM_PEER_SST_TESTS "CommPeer" writer "CPCommPattern=Peer" "${BASIC_SST_TESTS}" )

# temporarily remove PreciousTimestep CommPeer tests
list (REMOVE_ITEM COMM_PEER_SST_TESTS "PreciousTimestep")

MutateTestSet( FFS_SST_TESTS "FFS" writer "MarshalMethod=FFS" "${COMM_MIN_SST_TESTS};${COMM_PEER_SST_TESTS}" )
MutateTestSet( BP5_SST_TESTS "BP5" writer "MarshalMethod=BP5" "${COMM_MIN_SST_TESTS};${COMM_PEER_SST_TESTS}" )
MutateTestSet( BP_SST_TESTS "BP" writer "MarshalMethod=BP" "${COMM_MIN_SST_TESTS};${COMM_PEER_SST_TESTS}" )

# no SSE engine does Joined
list (FILTER BP_SST_TESTS EXCLUDE REGEX "Joined*")

set (SST_TESTS "")
LIST (APPEND SST_TESTS ${BP5_SST_TESTS} ${BP_SST_TESTS})

# Zero Data tests are unreliable with SST and BP marshaling
list (FILTER SST_TESTS EXCLUDE REGEX "2x1ZeroData.*BP")

# BP Marshalling doesn't support Struct data
list (FILTER SST_TESTS EXCLUDE REGEX "1x1Struct.*BP$")

foreach(test ${SST_TESTS})
    add_common_test(${test} SST)
endforeach()

if(ADIOS2_HAVE_MPI AND ADIOS2_RUN_MPI_MPMD_TESTS AND NOT MSVC)
    set (SSC_BASE_TESTS "1x1;1x1.Attrs;2x1;1x2;2x1ZeroDataVar;2x1ZeroDataR64;3x5;5x3;3x5LockGeometry")
    set (SSC_TESTS  ${SIMPLE_FORTRAN_TESTS} ${SIMPLE_MPI_FORTRAN_TESTS} ${SSC_BASE_TESTS})
    foreach(test ${SSC_TESTS})
        add_common_test(${test} SSC)
    endforeach()
endif()

#
#   Setup tests for BP engines
#

if(NOT WIN32)    # not on windows
    set (BP_TESTS ${ALL_SIMPLE_TESTS})
    # Delayed reader not worth testing on file engines
    list (FILTER BP_TESTS EXCLUDE REGEX "DelayedReader")
    # SharedVars fail with BP*
    list (FILTER BP_TESTS EXCLUDE REGEX ".*SharedVar$")
    # The nobody-writes-data-in-a-timestep tests don't work for any BP file engine
    list (FILTER BP_TESTS EXCLUDE REGEX ".*NoData$")
    # BP3 and BP4 don't do PerformDataWrite
    list (FILTER BP_TESTS EXCLUDE REGEX ".*DataWrite.*")
    # BP3 and BP4 don't do Modifiable Attributes
    list (FILTER BP_TESTS EXCLUDE REGEX ".*ModAttr.*")
    # BP3 and BP4 don't do VarDestruction
    list (FILTER BP_TESTS EXCLUDE REGEX ".*VarDestruction.*")
    # BP3 and BP4 don't do structs
    list (FILTER BP_TESTS EXCLUDE REGEX ".*1x1Struct.*")
    foreach(test ${BP_TESTS})
        add_common_test(${test} BP4)
    endforeach()
    # BP3 fails to handle lots of timesteps
    list (FILTER BP_TESTS EXCLUDE REGEX "Bulk.*")
    # BP3 doesn't do Joined
    list (FILTER BP_TESTS EXCLUDE REGEX "Joined.*")
    foreach(test ${BP_TESTS})
        add_common_test(${test} BP3)
    endforeach()
endif()

#  BP5 tests
set (BP5_TESTS ${ALL_SIMPLE_TESTS} ${SPECIAL_TESTS} ${BP5File_ONLY_TESTS})
# Delayed reader not worth testing on file engines
list (FILTER BP5_TESTS EXCLUDE REGEX "DelayedReader")
# Discard not a feature of BP5
list (FILTER BP5_TESTS EXCLUDE REGEX ".*DiscardWriter.1x1")
# PreciousTimestep not a feature of BP5
list (FILTER BP5_TESTS EXCLUDE REGEX ".*PreciousTimestep")
# LatestTimestep not a feature of BP5
list (FILTER BP5_TESTS EXCLUDE REGEX ".*LatestReader")
# KillWriter fails with BP5
list (FILTER BP5_TESTS EXCLUDE REGEX ".*KillWriter")
# KillReaders  We swear this isn't necessary for BP5 streaming
list (FILTER BP5_TESTS EXCLUDE REGEX ".*KillReaders")
foreach(test ${BP5_TESTS})
    add_common_test(${test} BP5)
endforeach()


#
#   Setup streaming tests for BP4 engine
#
if(NOT MSVC)    # not on windows
    # BP4 streaming tests start with all the simple tests, but with a timeout added on open
    LIST (APPEND BP4_STREAM_TESTS ${ALL_SIMPLE_TESTS} ${SPECIAL_TESTS})
    MutateTestSet( BP4_STREAM_TESTS "BPS" reader "OpenTimeoutSecs=10,BeginStepPollingFrequencySecs=0.1" "${BP4_STREAM_TESTS}")
    # no BP4 streaming doesn't do Joined?
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX "Joined*")
    # SharedVars fail with BP4_streaming*
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*SharedVar.BPS$")
   # Discard not a feature of BP4
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*DiscardWriter.1x1.*BPS$")
    # PreciousTimestep not a feature of BP4
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*Precious.*BPS$")
    # Timeout on Reader BeginStep failing in BP4
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*TimeoutReader.1x1.*BPS$")
    # LatestTimestep not a feature of BP4
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*LatestReader.*BPS$")
    # Preload not a feature of BP4_streaming
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*Preload.*BPS$")
    # KillWriter fails with BP4
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*KillWriter.*BPS$")
    # KillReaders  We swear this isn't necessary for BP4 streaming
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*KillReaders.*BPS$") 
    # SharedVars fail with BP4_streaming*
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*SharedVar.BPS$")
    # Local fail with BP4_streaming*
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*Local.BPS$")
    # BP3 and BP4 don't do VarDestruction
    list (FILTER BP4_STREAM_TESTS EXCLUDE REGEX ".*VarDestruction.*")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=ADIOS2
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname,,}")
pkgver=2.10.2
pkgrel=1
pkgdesc="The Adaptable Input/Output System version 2 (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://adios2.readthedocs.io/en/latest/"
msys2_repository_url="https://github.com/ornladios/ADIOS2/"
msys2_references=(
  'archlinux: adios2'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-blosc2"
         "${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libsodium"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
         "${MINGW_PACKAGE_PREFIX}-sqlite3"
         "${MINGW_PACKAGE_PREFIX}-zeromq"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-libffi"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-python-numpy")
source=(https://github.com/ornladios/ADIOS2/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        001-fix-build-on-mingw-w64.patch
        002-fix-build-on-clangarm64.patch
        003-no-regex_h-with-clang.patch)
sha256sums=('14cf0bcd94772194bce0f2c0e74dba187965d1cffd12d45f801c32929158579e'
            '8058f2265602ad7fbf762b3f5d2a97a4efaaa9348ff97a72c017dc4302a14c27'
            '0f365062c19c21cda137ccacbf1dd33bd00afdc3418299e2abae8aab5fba33b0'
            '379fe5edf3df2474edfe6515e0592af681c17f082fb4885b5cd554bdee11cd36')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-build-on-mingw-w64.patch \
    002-fix-build-on-clangarm64.patch \
    003-no-regex_h-with-clang.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == aarch64 ]]; then
    _extra_config+=("-DDILL_NATIVE_ONLY=OFF" "-DDILL_IGNORE_NATIVE=ON")
  fi

  CFLAGS+=" -Wno-implicit-function-declaration -Wno-int-conversion" \
  CXXFLAGS+=" -Wno-narrowing" \
  LDFLAGS+=" -Wl,--export-all-symbols" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -DADIOS2_USE_EXTERNAL_DEPENDENCIES=ON \
    -DADIOS2_USE_Blosc2=ON \
    -DADIOS2_USE_BZip2=ON \
    -DADIOS2_USE_DataMan=ON \
    -DADIOS2_USE_Fortran=ON \
    -DADIOS2_USE_HDF5=ON \
    -DADIOS2_USE_Python=ON \
    -DADIOS2_USE_PNG=ON \
    -DADIOS2_USE_ZeroMQ=ON \
    -DADIOS2_USE_DataMan=OFF \
    -DADIOS2_USE_DataSpaces=OFF \
    -DADIOS2_USE_Endian_Reverse=OFF \
    -DADIOS2_USE_IME=OFF \
    -DADIOS2_USE_MGARD=OFF \
    -DADIOS2_USE_MPI=OFF \
    -DADIOS2_USE_Profiling=OFF \
    -DADIOS2_USE_SST=OFF \
    -DADIOS2_USE_SZ=OFF \
    -DADIOS2_USE_ZFP=OFF \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -DADIOS2_BUILD_EXAMPLES=OFF \
    -DEVPATH_TRANSPORT_MODULES=OFF \
    -DBUILD_TESTING=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
  -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib"

  install -D -m644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/${_realname,,}/LICENSE
}
